# coding: utf-8

"""
    Passage Management API

    Passage's management API to manage your Passage apps and users.

    The version of the OpenAPI document: 1
    Contact: support@passage.id
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List
from passageidentity.openapi_client.models.magic_link_auth_method import MagicLinkAuthMethod
from passageidentity.openapi_client.models.otp_auth_method import OtpAuthMethod
from passageidentity.openapi_client.models.passkeys_auth_method import PasskeysAuthMethod
from typing import Optional, Set
from typing_extensions import Self

class AuthMethods(BaseModel):
    """
    Denotes what methods this app is allowed to use for authentication with configurations
    """ # noqa: E501
    passkeys: PasskeysAuthMethod
    otp: OtpAuthMethod
    magic_link: MagicLinkAuthMethod
    __properties: ClassVar[List[str]] = ["passkeys", "otp", "magic_link"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuthMethods from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of passkeys
        if self.passkeys:
            _dict['passkeys'] = self.passkeys.to_dict()
        # override the default output from pydantic by calling `to_dict()` of otp
        if self.otp:
            _dict['otp'] = self.otp.to_dict()
        # override the default output from pydantic by calling `to_dict()` of magic_link
        if self.magic_link:
            _dict['magic_link'] = self.magic_link.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuthMethods from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "passkeys": PasskeysAuthMethod.from_dict(obj["passkeys"]) if obj.get("passkeys") is not None else None,
            "otp": OtpAuthMethod.from_dict(obj["otp"]) if obj.get("otp") is not None else None,
            "magic_link": MagicLinkAuthMethod.from_dict(obj["magic_link"]) if obj.get("magic_link") is not None else None
        })
        return _obj


