# coding: utf-8

"""
    Passage Management API

    Passage's management API to manage your Passage apps and users.

    The version of the OpenAPI document: 1
    Contact: support@passage.id
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from passageidentity.openapi_client.models.social_connection_type import SocialConnectionType
from passageidentity.openapi_client.models.user_event_action import UserEventAction
from passageidentity.openapi_client.models.user_event_status import UserEventStatus
from typing import Optional, Set
from typing_extensions import Self

class UserRecentEvent(BaseModel):
    """
    UserRecentEvent
    """ # noqa: E501
    created_at: datetime
    completed_at: Optional[datetime]
    id: StrictStr
    ip_addr: StrictStr
    status: UserEventStatus
    type: StrictStr
    user_agent: StrictStr = Field(description="The raw user agent value from the originating device")
    user_agent_display: StrictStr = Field(description="A display-friendly version of the user agent")
    action: UserEventAction
    social_login_type: Optional[SocialConnectionType]
    __properties: ClassVar[List[str]] = ["created_at", "completed_at", "id", "ip_addr", "status", "type", "user_agent", "user_agent_display", "action", "social_login_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserRecentEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if completed_at (nullable) is None
        # and model_fields_set contains the field
        if self.completed_at is None and "completed_at" in self.model_fields_set:
            _dict['completed_at'] = None

        # set to None if social_login_type (nullable) is None
        # and model_fields_set contains the field
        if self.social_login_type is None and "social_login_type" in self.model_fields_set:
            _dict['social_login_type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserRecentEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": obj.get("created_at"),
            "completed_at": obj.get("completed_at"),
            "id": obj.get("id"),
            "ip_addr": obj.get("ip_addr"),
            "status": obj.get("status"),
            "type": obj.get("type"),
            "user_agent": obj.get("user_agent"),
            "user_agent_display": obj.get("user_agent_display"),
            "action": obj.get("action"),
            "social_login_type": obj.get("social_login_type")
        })
        return _obj


